The Member created by this endpoint will automatically be granted the stytch_admin Role. See the RBAC guide for more details on this Role.This method will fail if there is no present.If this method succeeds and the Member is not required to complete MFA, the Member will be logged in, granted an active session, and the session cookies will be minted and stored in the browser.If this method succeeds and MFA is required, the intermediate session token will be stored in the browser as a cookie.
Parameters
number
required
Set the session lifetime to be this many minutes from now. This will return both an opaque session_token and session_jwt for this session, which will automatically be stored in the browser cookies. The session_jwt will have a fixed lifetime of five minutes regardless of the underlying session duration, and will be automatically refreshed by the SDK in the background over time.This value must be a minimum of 5 and may not exceed the maximum session duration minutes value set in the Stytch Dashboard.A successful authentication will continue to extend the session this many minutes.
string
The name of the Organization.If the name is not specified, a default name will be created based on the email used to initiate the discovery flow:
If the email domain is a common email provider such as gmail.com, or if the email is a .edu email, the organization name will be generated based on the name portion of the email.
Otherwise, the organization name will be generated based on the email domain.
string
The unique URL slug of the Organization. A minimum of two characters is required. The slug only accepts alphanumeric characters and the following reserved characters: -._~.If the slug is not specified, a default slug will be created using the same logic as organization_name.
string
The image URL of the Organization logo.
object
The authentication setting that controls how a new Member can be provisioned by authenticating via Email Magic Link or OAuth. The accepted values are:
RESTRICTED – only new Members with verified emails that comply with email_allowed_domains can be provisioned upon authentication via Email Magic Link or OAuth.
NOT_ALLOWED – the default setting, disables JIT provisioning via Email Magic Link and OAuth.
string
The authentication setting that controls how a new Member can be invited to an organization by email. The accepted values are:
ALL_ALLOWED – any new Member can be invited to join via email.
RESTRICTED – only new Members with verified emails that comply with email_allowed_domains can be invited via email.
NOT_ALLOWED – disable email invites.
string
An array of email domains that allow invites or JIT provisioning for new Members. This list is enforced when either email_invites or email_jit_provisioning is set to RESTRICTED.
Common domains such as gmail.com are not allowed. See the full list.
string
The authentication setting that controls the JIT provisioning of Members when authenticating via SSO. The accepted values are:
ALL_ALLOWED – the default setting, new Members will be automatically provisioned upon successful authentication via any of the Organization’s sso_active_connections.
RESTRICTED – only new Members with SSO logins that comply with sso_jit_provisioning_allowed_connections can be provisioned upon authentication.
NOT_ALLOWED – disable JIT provisioning via SSO.
string
The setting that controls which authentication methods can be used by Members of an Organization. The accepted values are:
ALL_ALLOWED – the default setting which allows all authentication methods to be used.
RESTRICTED – only methods that comply with allowed_auth_methods can be used for authentication. This setting does not apply to Members with is_breakglass set to true.
string
An array of allowed authentication methods. This list is enforced when auth_methods is set to RESTRICTED. The list’s accepted values are: sso, magic_link, email_otp, password, google_oauth, microsoft_oauth, slack_oauth, github_oauth, and hubspot_oauth.
string
The setting that controls the MFA policy for all Members in the Organization. The accepted values are:
REQUIRED_FOR_ALL – All Members within the Organization will be required to complete MFA every time they wish to log in. However, any active Session that existed prior to this setting change will remain valid.
OPTIONAL – The default value. The Organization does not require MFA by default for all Members. Members will be required to complete MFA only if their mfa_enrolled status is set to true.
Response
string
The unique ID of the Member.
object
The new Stytch Session.
Show properties
string
Globally unique UUID that identifies the Session.
string
Globally unique UUID that identifies a specific Member.
array[objects]
An array of authentication factors that comprise a Session.
Show properties
string
The type of authentication factor. The possible values are: email_otp, impersonated, imported, magic_link, oauth, otp, password, recovery_codes, sso, trusted_auth_token, or totp.
string
The method that was used to deliver the authentication factor. The possible values depend on the type:
email_otp: Only email.
impersonated: Only impersonation.
imported: Only imported_auth0.
magic_link: Only email.
oauth: oauth_google, oauth_microsoft, oauth_hubspot, oauth_slack, or oauth_github.
You may see an ‘exchange’ delivery method when a non-email-verifying OAuth factor originally authenticated in one organization is exchanged for a factor in another organization. This can happen during authentication flows such as session exchange. The non-email-verifying OAuth providers are Hubspot, Slack, and Github. Google is also considered non-email-verifying when the HD claim is empty. The possible exchange values are oauth_exchange_google, oauth_exchange_hubspot, oauth_exchange_slack, or oauth_exchange_github. The final possible value is oauth_access_token_exchange, if this factor came from an access token exchange flow.
otp: Only sms.
password: Only knowledge.
recovery_codes: Only recovery_code.
sso: sso_saml or sso_oidc.
trusted_auth_token: Only trusted_token_exchange.
totp: Only authenticator_app.
string
The timestamp when the factor was initially authenticated.
string
The timestamp when the factor was last authenticated.
string
The timestamp when the factor was last updated.
string
Either PRIMARY or SECONDARY. Secondary factor types include otp, totp, and recovery_codes. All other factors are primary.
object
Information about the email factor, if one is present.
Show properties
string
The email address of the Member.
string
The globally unique UUID of the Member’s email.
object
Information about the phone number factor, if one is present.
Show properties
string
The phone number.
string
The globally unique UUID of the phone number.
object
Information about the Google OAuth factor, if one is present.
Show properties
string
The unique ID of the OAuth registration.
string
The globally unique UUID of the Member’s email.
string
The unique identifier for the User within the OAuth provider. Also commonly called the sub or “Subject field” in OAuth protocols.
object
Information about the Microsoft OAuth factor, if one is present.
Show properties
string
The unique ID of the OAuth registration.
string
The globally unique UUID of the Member’s email.
string
The unique identifier for the User within the OAuth provider. Also commonly called the sub or “Subject field” in OAuth protocols.
object
Information about the Hubspot OAuth factor, if one is present.
Show properties
string
The unique ID of the OAuth registration.
string
The globally unique UUID of the Member’s email.
string
The unique identifier for the User within the OAuth provider. Also commonly called the sub or “Subject field” in OAuth protocols.
object
Information about the Github OAuth factor, if one is present.
Show properties
string
The unique ID of the OAuth registration.
string
The globally unique UUID of the Member’s email.
string
The unique identifier for the User within the OAuth provider. Also commonly called the sub or “Subject field” in OAuth protocols.
object
Information about the Slack OAuth factor, if one is present.
Show properties
string
The unique ID of the OAuth registration.
string
The globally unique UUID of the Member’s email.
string
The unique identifier for the User within the OAuth provider. Also commonly called the sub or “Subject field” in OAuth protocols.
object
Information about the Google OAuth Exchange factor, if one is present.
Show properties
string
The globally unique UUID of the email address.
object
Information about the Hubspot OAuth Exchange factor, if one is present.
Show properties
string
The globally unique UUID of the email address.
object
Information about the Github OAuth Exchange factor, if one is present.
Show properties
string
The globally unique UUID of the email address.
object
Information about the Slack OAuth Exchange factor, if one is present.
Show properties
string
The globally unique UUID of the email address.
object
Information about the SAML SSO factor, if one is present.
Show properties
string
The unique ID of an SSO Registration.
string
Globally unique UUID that identifies a specific SAML Connection.
string
The ID of the member given by the identity provider.
object
Information about the OIDC SSO factor, if one is present.
Show properties
string
The unique ID of an SSO Registration.
string
Globally unique UUID that identifies a specific OIDC Connection.
string
The ID of the member given by the identity provider.
object
Information about the TOTP-backed Authenticator App factor, if one is present.
Show properties
string
Globally unique UUID that identifies the TOTP instance.
object
Information about the impersonated factor, if one is present.
Show properties
string
For impersonated sessions initiated via the Stytch Dashboard, the impersonator’s Stytch Dashboard member_id.
string
The email address of the impersonator.
object
Information about the trusted auth token factor, if one is present.
Show properties
string
The ID of the trusted auth token.
object
Information about the access token exchange factor, if one is present.
Show properties
string
The ID of the Connected App client.
The globally unique UUID that identifies the Organization associated with the Session.
The unique URL slug of the Organization associated with the Session.
array[string]
A list of the roles associated with the Session.
Members may inherit certain roles depending on the factors in their Session.
For example, some roles may only be active if the member logged in from a specific SAML IDP.
string
The timestamp when the Session was created. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.
string
The timestamp when the Session was last accessed. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.
string
The timestamp when the Session expires. Values conform to the RFC 3339 standard and are expressed in UTC, e.g. 2021-12-29T12:33:09Z.
map<string, any>
The custom claims map for a Session. Claims can be added to a Session during a Sessions authenticate call.
object
The Member object of the signed-in Member.
Show properties
string
Globally unique UUID that identifies a specific Organization.
string
Globally unique UUID that identifies a specific Member.
string
The ID of the Member given by the identity provider.
string
The email address of the Member.
boolean
Whether or not the Member’s email address is verified.
string
The status of the Member. The possible values are: pending, invited, active, or deleted.
string
The name of the Member.
object[]
An array of registered SAML Connection or OIDC Connection objects the Member has authenticated with.
Show sso_registration properties
string
Globally unique UUID that identifies a specific SSO connection_id for a Member.
string
The unique ID of an SSO Registration.
string
The ID of the Member given by the identity provider.
object
An object for storing SSO attributes brought over from the identity provider.
object
Sets whether the Member is enrolled in MFA.
Show sso_registration properties
string
The id of the SCIM Connection.
string
The unique ID of a SCIM Registration.
string
The ID of the Member given by the identity provider.
object
An object for storing SCIM attributes brought over from the identity provider.
boolean
Identifies the Member as a break glass user - someone who has permissions to authenticate into an Organization by bypassing the Organization’s settings.A break glass account is typically used for emergency purposes to gain access outside of normal authentication procedures. Refer to the Organization object and its auth_methods and allowed_auth_methods fields for more details.
string
Globally unique UUID that identifies a Member’s password.
object[]
A list of OAuth registrations for this Member.
Show oauth_registrations properties
string
Denotes the OAuth identity provider that the user has authenticated with, e.g. Google, Microsoft, GitHub etc.
string
The unique identifier for the User within a given OAuth provider. Also commonly called the sub or “Subject field” in OAuth protocols.
string
If available, the profile_picture_url is a URL of the User’s profile picture set in the OAuth identity provider that the User has authenticated with, e.g. Google profile picture.
string
If available, the locale is the Member’s locale set in the OAuth identity provider that the user has authenticated with.
string
The unique ID of an OAuth registration.
boolean
Sets whether the Member is enrolled in MFA.If true, the Member must complete an MFA step whenever they wish to log in to their Organization.If false, the Member only needs to complete an MFA step if the Organization’s MFA policy is set to REQUIRED_FOR_ALL.
string
The Member’s phone number. A Member may only have one phone number.The phone number should be in E.164 format (i.e. +1XXXXXXXXXX).
boolean
Whether or not the Member’s phone number is verified.
object[]
A list of retired email addresses for this Member. A previously active email address can be marked as retired in one of two ways:
It’s replaced with a new primary email address during an explicit Member update.
A new email address is surfaced by an OAuth, SAML or OIDC provider. In this case the new email address becomes the Member’s primary email address and the old primary email address is retired. A retired email address cannot be used by other Members in the same Organization. However, unlinking retired email addresses allows them to be subsequently re-used by other Organization Members. Retired email addresses can be unlinked using the Unlink Retired Email endpoint.
Show properties
string
The globally unique UUID of a Member’s email.
string
The email address of the Member.
object
An arbitrary JSON object for storing application-specific data or identity-provider-specific data.
object
An arbitrary JSON object of application-specific data. These fields can be edited directly by the frontend SDK, and should not be used to store critical information. See the Metadata resource for complete field behavior details.
object[]
Explicit or implicit Roles assigned to this Member, along with details about the role assignment source. See the RBAC guide for more information about role assignment.
Show roles properties
string
The unique identifier of the RBAC Role, provided by the developer and intended to be human-readable.Reserved role_ids that are predefined by Stytch include:
A list of sources for this role assignment. A role assignment can come from multiple sources - for example, the Role could be both explicitly assigned and implicitly granted from the Member’s email domain.
Show sources properties
string
The type of role assignment. The possible values are:
direct_assignment – an explicitly assigned Role. Directly assigned roles can be updated by passing in the roles argument to the Update Member endpoint.
email_assignment – an implicit Role granted by the Member’s email domain, regardless of their login method. Email implicit role assignments can be updated by passing in the rbac_email_implicit_role_assignments argument to the Update Organization endpoint.
sso_connection – an implicit Role granted by the Member’s SSO connection. This is currently only available for SAML connections and not for OIDC. If the Member has a SAML Member registration with the given connection, this role assignment will appear in the list. However, for authorization check purposes (in sessions authenticate or in any endpoint that enforces RBAC with session headers), the Member will only be granted the Role if their session contains an authentication factor with the specified SAML connection. SAML connection implicit role assignments can be updated by passing in the saml_connection_implicit_role_assignments argument to the Update SAML connection endpoint.
sso_connection_group – an implicit Role granted by the Member’s SSO connection and group. This is currently only available for SAML connections and not for OIDC. If the Member has a SAML Member registration with the given connection, and belongs to a specific group within the IdP, this role assignment will appear in the list. However, for authorization check purposes (in sessions authenticate or in any endpoint that enforces RBAC with session headers), the Member will only be granted the role if their session contains an authentication factor with the specified SAML connection.
scim_connection_group – an implicit Role granted by the Member’s SCIM connection and group. If the Member has a SCIM Member registration with the given connection, and belongs to a specific group within the IdP, this role assignment will appear in the list. SCIM group implicit role assignments can be updated by passing in the scim_group_implicit_role_assignments argument to the Update SCIM connection endpoint.
object
An object containing additional metadata about the source assignment. The fields will vary depending on the role assignment type as follows:
direct_assignment – no additional details.
email_assignment – will contain the email domain that granted the assignment.
sso_connection – will contain the connection_id of the SAML connection that granted the assignment.
sso_connection_group – will contain the connection_id of the SAML connection and the name of the group that granted the assignment.
scim_connection_group – will contain the connection_id of the SAML connection and the group_id that granted the assignment.
boolean
Whether or not the Member has the stytch_admin Role. This Role is automatically granted to Members who create an Organization through the discovery flow. See the RBAC guide for more details on this Role.
string
The date and time the Member was created.
string
The date and time the Member was last updated.
object
The Organization object of the Organization the Member has signed into.
Show properties
string
Globally unique UUID that identifies a specific Organization. The organization_id is critical to perform operations on an Organization, so be sure to preserve this value. You may also use the organization_slug or organization_external_id here as a convenience.
string
The name of the Organization. Must be between 1 and 128 characters in length.
string
The image URL of the Organization logo.
string
The unique URL slug of the Organization.The slug only accepts alphanumeric characters and the following reserved characters: - . _ ~. Must be between 2 and 128 characters in length.Wherever an organization_id is expected in a path or request parameter, you may also use the organization_slug as a convenience.
Globally unique UUID that identifies a specific SSO connection_id for a Member.
string
A human-readable display name for the connection.
array[strings]
An array of email domains that allow invites or JIT provisioning for new Members. This list is enforced when either email_invites or email_jit_provisioning is set to RESTRICTEDCommon domains such as gmail.com are not allowed. See the full list of disallowed common email domains.
string
The authentication setting that controls how a new Member can be provisioned by authenticating via Email Magic Link or OAuth. The accepted values are:
RESTRICTED – only new Members with verified emails that comply with email_allowed_domains can be provisioned upon authentication via Email Magic Link or OAuth
NOT_ALLOWED – the default setting, disables JIT provisioning via Email Magic Link and OAuth
string
The setting that controls which authentication methods can be used by Members of an Organization. The accepted values are:
ALL_ALLOWED – the default setting which allows all authentication methods to be used
RESTRICTED – only methods that comply with allowed_auth_methods can be used for authentication. This setting does not apply to Members with is_breakglass set to true
array[strings]
An array of allowed authentication methods. This list is enforced when auth_methods is set to RESTRICTED. The list’s accepted values are: sso, magic_link, email_otp, password, google_oauth, microsoft_oauth, slack_oauth, github_oauth, and hubspot_oauth.
string
The default connection used for SSO when there are multiple active connections.
string
The authentication setting that controls how a new Member can JIT provision into an Organization by tenant. The accepted values are:
RESTRICTED – only new Members with tenants in allowed_oauth_tenants can JIT provision via tenant
NOT_ALLOWED – the default setting, disables JIT provisioning by OAuth Tenant
object
A map of allowed OAuth tenants. If this field is not passed in, the Organization will not allow JIT provisioning by OAuth Tenant. Allowed keys are “slack”, “hubspot”, and “github”.
string
The JWT for the new Stytch Session.
If the project is configured to use HttpOnly cookies, this field will always be an empty string.
string
The secret token for the new Stytch Session.
If the project is configured to use HttpOnly cookies, this field will always be an empty string.
object
If Protected Auth is enabled and returned fingerprinting results, this field will contain information about the member’s device attributes.
Show properties
string
The IP address of the device.
object
The details of the IP address.
string
The city of the IP address.
string
The region of the IP address.
string
The country of the IP address.
object
The details of the country.
boolean
Indicates whether the Member is fully authenticated. If false, the Member needs to complete an MFA step to log in to the Organization.
string
The intermediate_session_token that should be passed into a secondary authentication endpoint, such as OTP authenticate, in order to receive a member session. The intermediate_session_token can also be used with discovery endpoints to join a different organization or create a new organization.If the member is fully authenticated, this field will be an empty string.
If the project is configured to use HttpOnly cookies, this field will always be an empty string.
object | null
The types of primary authentication required.
Show properties
string[]
The allowed authentication methods. The possible values are: sso, magic_link, email_otp, password, google_oauth, microsoft_oauth, slack_oauth, github_oauth, and hubspot_oauth.
object | null
The types of secondary authentication required to join the Organization.
Show properties
object | null
Show properties
string
Whether the Member has SMS OTP enrolled.
'sms_otp' | null
Equal to sms_otp if an OTP code was sent to the member’s phone number, else null.
object
If Protected Auth is enabled and returned fingerprinting results, this field will contain information about the member’s device attributes.
Show properties
string
The IP address of the device.
object
The details of the IP address.
string
The city of the IP address.
string
The region of the IP address.
string
The country of the IP address.
object
The details of the country.
Assistant
Responses are generated using AI and may contain mistakes.